import { SassFormatterConfig, SassTextLine, SassFormattingOptions } from './format.provider';
export interface FormatContext {
    convert: {
        lastSelector: string;
        wasLastLineCss: boolean;
    };
    keyframes: {
        is: boolean;
        tabs: number;
    };
    tabs: number;
    currentTabs: number;
}
export interface FormatLocalContext {
    ResetTabs: boolean;
    isAnd_: boolean;
    isProp: boolean;
    indentation: {
        offset: number;
        distance: number;
    };
    isClassOrIdSelector: boolean;
    isIfOrElse: boolean;
    isIfOrElseAProp: boolean;
    isKeyframes: boolean;
    isKeyframesPoint: boolean;
}
export declare function FormatHandleBlockHeader(i: {
    line: SassTextLine;
    options: SassFormattingOptions;
    config: SassFormatterConfig;
    enableDebug: boolean;
    LocalContext: FormatLocalContext;
    offset: number;
    Context: FormatContext;
}): {
    edit: string;
    context: FormatContext;
    additionalTabs: number;
};
export declare function FormatHandleProperty(i: {
    line: SassTextLine;
    options: SassFormattingOptions;
    config: SassFormatterConfig;
    enableDebug: boolean;
    LocalContext: FormatLocalContext;
    Context: FormatContext;
}): {
    edit: string;
    context: FormatContext;
};
export declare function FormatHandleLocalContext(line: SassTextLine, CONTEXT: FormatContext, options: SassFormattingOptions): {
    isIfOrElse: boolean;
    isIfOrElseAProp: boolean;
    isKeyframes: boolean;
    isKeyframesPoint: boolean;
};
