export interface SassFormatterConfig {
    enabled?: boolean;
    debug?: boolean;
    deleteCompact?: boolean;
    deleteEmptyRows?: boolean;
    deleteWhitespace?: boolean;
    convert?: boolean;
    replaceSpacesOrTabs?: boolean;
    setPropertySpace?: boolean;
}
export interface SassFormattingOptions {
    tabSize: number;
    insertSpaces: boolean;
}
export declare class SassTextLine {
    lineNumber: number;
    text: string;
    isEmptyOrWhitespace: boolean;
    constructor(text: string, lineNumber: number);
}
export declare class SassTextDocument {
    private lines;
    lineCount: number;
    rawText: string;
    constructor(text: string);
    lineAt(lineNumber: number): SassTextLine;
}
export declare class SassFormatter {
    static Format(document: SassTextDocument, options: SassFormattingOptions, config?: SassFormatterConfig): string;
}
